diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipeEntryCraftingGroup.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipeEntryCraftingGroup.java
new file mode 100644
index 000000000..07b82e2ee
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipeEntryCraftingGroup.java
@@ -0,0 +1,57 @@
+package net.minecraft.client.gui.guidebook.crafting;
+
+import net.minecraft.core.data.registry.recipe.SearchQuery;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.player.inventory.container.ContainerCrafting;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class RecipeEntryCraftingGroup extends RecipeEntryCrafting<Void, Void> {
+    public final RecipeEntryCrafting<?, ?> representative;
+    public final List<RecipeEntryCrafting<?, ?>> variants;
+
+    public RecipeEntryCraftingGroup(List<RecipeEntryCrafting<?, ?>> variants) {
+        this.variants = variants;
+        this.representative = variants.get(0);
+        this.parent = representative.parent;
+    }
+
+    @Override
+    public boolean matches(ContainerCrafting containerCrafting) {
+        return false;
+    }
+
+    @Override
+    public boolean matchesQuery(SearchQuery query) {
+        for (RecipeEntryCrafting<?, ?> variant : variants) {
+            if (variant.matchesQueryIgnoreExceptions(query)) {
+                return true;
+            }
+        }
+        return false;
+    }
+
+    public RecipeEntryCraftingGroup filterToQuery(SearchQuery query) {
+        List<RecipeEntryCrafting<?, ?>> matching = new ArrayList<>();
+        for (RecipeEntryCrafting<?, ?> variant : variants) {
+            if (variant.matchesQueryIgnoreExceptions(query)) {
+                matching.add(variant);
+            }
+        }
+        if (matching.isEmpty()) return null;
+        if (matching.size() == variants.size()) return this;
+        return new RecipeEntryCraftingGroup(matching);
+    }
+
+    @Override
+    public ItemStack getCraftingResult(ContainerCrafting containerCrafting) {
+        return representative.getCraftingResult(containerCrafting);
+    }
+
+    @Override
+    public int getRecipeSize() {
+        return representative.getRecipeSize();
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
index e0b69fe01..37421a4a6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
@@ -8,6 +8,7 @@ import net.minecraft.client.gui.guidebook.GuidebookSection;
 import net.minecraft.client.gui.guidebook.GuidebookSections;
 import net.minecraft.client.gui.guidebook.GuidebookPageManager;
 import net.minecraft.client.gui.guidebook.RecipePage;
+import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterCraftingGroup;
 import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterDyeing;
 import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterLabel;
 import net.minecraft.client.gui.guidebook.crafting.displays.DisplayAdapterLabelDye;
@@ -67,6 +68,7 @@ public class RecipePageCrafting
         recipeToDisplayAdapterMap.put(RecipeEntryMapDuplication.class, new DisplayAdapterMapDuplication());
         recipeToDisplayAdapterMap.put(RecipeEntryUndyeing.class, new DisplayAdapterUndye());
         recipeToDisplayAdapterMap.put(RecipeEntryDyeing.class, new DisplayAdapterDyeing());
+        recipeToDisplayAdapterMap.put(RecipeEntryCraftingGroup.class, new DisplayAdapterCraftingGroup());
     }
 
     private final TooltipElement tooltipElement;
@@ -74,7 +76,7 @@ public class RecipePageCrafting
     private static final Minecraft mc = Minecraft.getMinecraft();
     private static long ticks = 0;
 
-    public RecipePageCrafting(GuidebookSection section, List<RecipeEntryCrafting<?, ?>> recipes) {
+    public RecipePageCrafting(GuidebookSection section, List<RecipeEntryCrafting<?, ?>> recipes, SearchQuery searchQuery) {
         super(section);
         this.recipes = recipes;
         this.slots = new ArrayList<>();
@@ -88,6 +90,11 @@ public class RecipePageCrafting
             if (recipeToDisplayAdapterMap.containsKey(recipe.getClass())) {
                 RecipeDisplayAdapter adapter = recipeToDisplayAdapterMap.get(recipe.getClass());
                 List<SlotGuidebook> recipeSlots = adapter.getSlots(recipe, recipeAmount, xOffset, yOffset);
+                if (searchQuery != null) {
+                    for (SlotGuidebook slot : recipeSlots) {
+                        slot.applySearchFilter(searchQuery);
+                    }
+                }
                 this.map.put(recipe, recipeSlots);
                 this.slots.addAll(recipeSlots);
                 yOffset += 10;
@@ -97,6 +104,10 @@ public class RecipePageCrafting
 
     }
 
+    public RecipePageCrafting(GuidebookSection section, List<RecipeEntryCrafting<?, ?>> recipes) {
+        this(section, recipes, null);
+    }
+
     @Override
     public void onTick() {
         ticks++;
@@ -110,6 +121,13 @@ public class RecipePageCrafting
         }
     }
 
+    @Override
+    public void onBecomeVisible() {
+        for (SlotGuidebook slot : this.slots) {
+            slot.randomizeCycleStart();
+        }
+    }
+
     @Override
     protected void renderForeground(TextureManager re, FontRenderer sr, int x, int y, int mouseX, int mouseY, float partialTicks) {
         if (this.recipes.isEmpty()) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterCraftingGroup.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterCraftingGroup.java
new file mode 100644
index 000000000..d120be396
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/DisplayAdapterCraftingGroup.java
@@ -0,0 +1,221 @@
+package net.minecraft.client.gui.guidebook.crafting.displays;
+
+import net.minecraft.client.gui.guidebook.SlotGuidebook;
+import net.minecraft.client.gui.guidebook.crafting.RecipeEntryCraftingGroup;
+import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
+import net.minecraft.core.data.registry.recipe.RecipeSymbol;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCrafting;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
+import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
+import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.List;
+import java.util.Random;
+
+public class DisplayAdapterCraftingGroup implements RecipeDisplayAdapter<RecipeEntryCraftingGroup> {
+    @Override
+    public List<SlotGuidebook> getSlots(@NotNull RecipeEntryCraftingGroup recipe, int recipeAmount, int xOffset, int yOffset) {
+        List<RecipeEntryCrafting<?, ?>> variants = recipe.variants;
+
+        List<List<RecipeSymbol>> variantInputs = new ArrayList<>();
+        List<ItemStack> variantOutputs = new ArrayList<>();
+        for (RecipeEntryCrafting<?, ?> variant : variants) {
+            variantInputs.add(inputSymbols(variant));
+            variantOutputs.add(outputStack(variant));
+        }
+
+        GroupCursor cursor = new GroupCursor(variants.size());
+        if (recipe.representative instanceof RecipeEntryCraftingShaped shaped) {
+            return buildGrid(shaped.recipeWidth, shaped.recipeHeight, variantInputs, variantOutputs, recipeAmount, xOffset, yOffset, cursor, recipe);
+        }
+        return buildShapeless(variantInputs, variantOutputs, recipeAmount, xOffset, yOffset, cursor, recipe);
+    }
+
+    private static List<RecipeSymbol> inputSymbols(RecipeEntryCrafting<?, ?> variant) {
+        if (variant instanceof RecipeEntryCraftingShaped shaped) return Arrays.asList(shaped.getInput());
+        if (variant instanceof RecipeEntryCraftingShapeless shapeless) return shapeless.getInput();
+        return new ArrayList<>();
+    }
+
+    private static ItemStack outputStack(RecipeEntryCrafting<?, ?> variant) {
+        if (variant instanceof RecipeEntryCraftingShaped shaped) return shaped.getOutput();
+        if (variant instanceof RecipeEntryCraftingShapeless shapeless) return shapeless.getOutput();
+        return null;
+    }
+
+    private static List<SlotGuidebook> buildGrid(
+            int width, int height, List<List<RecipeSymbol>> variantInputs, List<ItemStack> variantOutputs,
+            int recipeAmount, int xOffset, int yOffset, GroupCursor cursor, RecipeEntryBase<?, ?, ?> recipe) {
+        List<SlotGuidebook> recipeSlots = new ArrayList<>();
+        boolean[] driverAssigned = {false};
+
+        if (height > 2 || width > 2) {
+            for (int i = 0; i < 9; i++) {
+                final int slotX = i % 3;
+                final int slotY = i / 3;
+                final int x = 1 + 18 * (i % 3) + xOffset;
+                final int y = 1 + 18 * ((i / 3) + recipeAmount * 3) + yOffset;
+                if (slotX >= width || slotY >= height) {
+                    recipeSlots.add(new SlotGuidebook(i, x, y, null, false, recipe));
+                } else {
+                    recipeSlots.add(makeInputSlot(i, x, y, slotX + slotY * width, variantInputs, cursor, driverAssigned, recipe));
+                }
+            }
+            int centerY = (recipeSlots.get(recipeSlots.size() - 1).y + recipeSlots.get(recipeSlots.size() - 8).y) / 2;
+            recipeSlots.add(makeOutputSlot(9, 81 + xOffset, centerY, variantOutputs, cursor, driverAssigned, recipe));
+        } else {
+            for (int i = 0; i < 4; i++) {
+                final int slotX = i % 2;
+                final int slotY = i / 2;
+                final int x = 13 + 18 * (i % 2) + xOffset;
+                final int y = 10 + 18 * ((i / 2) + recipeAmount * 3) + yOffset;
+                if (slotX >= width || slotY >= height) {
+                    recipeSlots.add(new SlotGuidebook(i, x, y, null, false, recipe));
+                } else {
+                    recipeSlots.add(makeInputSlot(i, x, y, slotX + slotY * width, variantInputs, cursor, driverAssigned, recipe));
+                }
+            }
+            int centerY = (recipeSlots.get(recipeSlots.size() - 1).y + recipeSlots.get(recipeSlots.size() - 3).y) / 2;
+            recipeSlots.add(makeOutputSlot(4, 81 + xOffset, centerY, variantOutputs, cursor, driverAssigned, recipe));
+        }
+        return recipeSlots;
+    }
+
+    private static List<SlotGuidebook> buildShapeless(List<List<RecipeSymbol>> variantInputs, List<ItemStack> variantOutputs,
+                                                      int recipeAmount, int xOffset, int yOffset, GroupCursor cursor, RecipeEntryBase<?, ?, ?> recipe) {
+        List<SlotGuidebook> recipeSlots = new ArrayList<>();
+        boolean[] driverAssigned = {false};
+        int inputCount = variantInputs.get(0).size();
+
+        if (inputCount > 4) {
+            for (int i = 0; i < 9; i++) {
+                final int x = 1 + 18 * (i % 3) + xOffset;
+                final int y = 1 + 18 * ((i / 3) + recipeAmount * 3) + yOffset;
+                if (i >= inputCount) {
+                    recipeSlots.add(new SlotGuidebook(i, x, y, null, false, recipe));
+                } else {
+                    recipeSlots.add(makeInputSlot(i, x, y, i, variantInputs, cursor, driverAssigned, recipe));
+                }
+            }
+            int centerY = (recipeSlots.get(recipeSlots.size() - 1).y + recipeSlots.get(recipeSlots.size() - 8).y) / 2;
+            recipeSlots.add(makeOutputSlot(9, 81 + xOffset, centerY, variantOutputs, cursor, driverAssigned, recipe));
+        } else {
+            for (int i = 0; i < 4; i++) {
+                final int x = 13 + 18 * (i % 2) + xOffset;
+                final int y = 10 + 18 * ((i / 2) + recipeAmount * 3) + yOffset;
+                if (i >= inputCount) {
+                    recipeSlots.add(new SlotGuidebook(i, x, y, null, false, recipe));
+                } else {
+                    recipeSlots.add(makeInputSlot(i, x, y, i, variantInputs, cursor, driverAssigned, recipe));
+                }
+            }
+            int centerY = (recipeSlots.get(recipeSlots.size() - 1).y + recipeSlots.get(recipeSlots.size() - 3).y) / 2;
+            recipeSlots.add(makeOutputSlot(4, 81 + xOffset, centerY, variantOutputs, cursor, driverAssigned, recipe));
+        }
+        return recipeSlots;
+    }
+
+    private static @NotNull SlotGuidebook makeInputSlot(int id, int x, int y, int inputIndex, @NotNull List<List<RecipeSymbol>> variantInputs,
+                                                        GroupCursor cursor, boolean[] driverAssigned, RecipeEntryBase<?, ?, ?> recipe) {
+        List<RecipeSymbol> symbols = new ArrayList<>();
+        for (List<RecipeSymbol> inputs : variantInputs) {
+            symbols.add(inputs.get(inputIndex));
+        }
+        boolean driver = !driverAssigned[0];
+        if (driver) driverAssigned[0] = true;
+        return SlotGuidebookCraftingGroup.forInputs(id, x, y, symbols, cursor, driver, recipe);
+    }
+
+    private static @NotNull SlotGuidebook makeOutputSlot(int id, int x, int y, @NotNull List<ItemStack> variantOutputs,
+                                                         GroupCursor cursor, boolean[] driverAssigned, RecipeEntryBase<?, ?, ?> recipe) {
+        List<ItemStack> frames = new ArrayList<>();
+        for (ItemStack output : variantOutputs) {
+            frames.add(output == null ? null : output.copy());
+        }
+        boolean driver = !driverAssigned[0];
+        if (driver) driverAssigned[0] = true;
+        return SlotGuidebookCraftingGroup.forOutputs(id, x, y, frames, cursor, driver, recipe).setAsOutput();
+    }
+
+    static final class GroupCursor {
+        private static final Random RANDOM = new Random();
+        final int variantCount;
+        int main;
+        int nested;
+
+        GroupCursor(int variantCount) {
+            this.variantCount = variantCount;
+            randomizeStart();
+        }
+
+        void advance() {
+            main = variantCount <= 0 ? 0 : (main + 1) % variantCount;
+            nested++;
+        }
+
+        void randomizeStart() {
+            main = variantCount <= 0 ? 0 : RANDOM.nextInt(variantCount);
+            nested = RANDOM.nextInt(4096);
+        }
+    }
+
+    public static class SlotGuidebookCraftingGroup extends SlotGuidebook {
+        private final List<RecipeSymbol> symbols; // input slots; null for output slots
+        private final List<ItemStack> items;      // output slots; null for input slots
+        private final GroupCursor cursor;
+        private final boolean driver;
+
+        private SlotGuidebookCraftingGroup(int id, int x, int y, List<RecipeSymbol> symbols, List<ItemStack> items,
+                                           GroupCursor cursor, boolean driver, RecipeEntryBase<?, ?, ?> recipe) {
+            super(id, x, y, null, false, recipe);
+            this.symbols = symbols;
+            this.items = items;
+            this.cursor = cursor;
+            this.driver = driver;
+            resolve();
+        }
+
+        static SlotGuidebookCraftingGroup forInputs(int id, int x, int y, List<RecipeSymbol> symbols, GroupCursor cursor, boolean driver, RecipeEntryBase<?, ?, ?> recipe) {
+            return new SlotGuidebookCraftingGroup(id, x, y, symbols, null, cursor, driver, recipe);
+        }
+
+        static SlotGuidebookCraftingGroup forOutputs(int id, int x, int y, List<ItemStack> items, GroupCursor cursor, boolean driver, RecipeEntryBase<?, ?, ?> recipe) {
+            return new SlotGuidebookCraftingGroup(id, x, y, null, items, cursor, driver, recipe);
+        }
+
+        @Override
+        public SlotGuidebookCraftingGroup setAsOutput() {
+            super.setAsOutput();
+            return this;
+        }
+
+        private void resolve() {
+            int index = cursor.variantCount <= 0 ? 0 : Math.min(cursor.main, cursor.variantCount - 1);
+            if (symbols != null) {
+                if (symbols.isEmpty()) { this.item = null; return; }
+                RecipeSymbol symbol = symbols.get(index);
+                if (symbol == null) { this.item = null; return; }
+                List<ItemStack> members = symbol.resolve();
+                if (members == null || members.isEmpty()) { this.item = null; return; }
+                this.item = members.get(Math.floorMod(cursor.nested, members.size()));
+            } else if (items != null) {
+                this.item = items.isEmpty() ? null : items.get(index);
+            }
+        }
+
+        @Override
+        public void showRandomItem() {
+            if (driver) cursor.advance();
+            resolve();
+        }
+
+        @Override
+        public void randomizeCycleStart() {
+            if (driver) cursor.randomizeStart();
+            resolve();
+        }
+    }
+}
